
import java.io.File;
import java.io.IOException;
import java.util.ResourceBundle;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiUnavailableException;

import sdljava.SDLException;
import sdljava.ttf.SDLTTF;
import sdljava.video.SDLSurface;

public class Options {

	private static boolean online;
	private boolean end ; //determina cuando salir del programa
	private boolean fullscreen ;

	private Text text;
	
	private Text textArial15;
	private Text textArabica10;
	private Text textArabica8;
	private Text textCalculator20;
	private Text textCalculator40;
	
	private Text textCalculator15;
	
	private Text textHand20;



	private CFrame frameBackgroundOptions;
	private CSprite spriteBackgroundOptions;
	
	private Event event;
	
	private CFrame framebordercircleoff;
	private CFrame framebordercircleon;
	private CFrame frameborderoff;
	private CFrame frameborderon;
	private CFrame framebuttoncircle;
	private CFrame framebuttonoff;
	private CFrame framebuttonon;
	
	private CSprite spritebordercircle;
	private CSprite spriteborder;
	private CSprite spritebutton;
	private CSprite spritebuttoncircle;
	
	private Keyboard keyboard;

  
	private  int maxoption;

	private int numoption;

	static  int staffmode;
    

	private  int frameskipmax;

	
	public boolean getFullscreen(){
		return this.fullscreen;
	}
    public void initsprites() throws SDLException, IOException{
		
    	//init sprites

    			framebordercircleoff= new CFrame();
    			framebordercircleon= new CFrame();
    			frameborderoff= new CFrame();
    			frameborderon= new CFrame();
    			framebuttoncircle= new CFrame();
    			framebuttonoff= new CFrame();
    			framebuttonon= new CFrame();
    				
    			spritebordercircle = new CSprite();
    			spriteborder = new CSprite();
    			spritebutton = new CSprite();
    			spritebuttoncircle = new CSprite();

    			frameBackgroundOptions = new CFrame();
    			spriteBackgroundOptions = new CSprite();
    
    			framebordercircleoff.load("sprites"+  File.separator + "bordercircleoff.png");
    			framebordercircleon.load("sprites"+  File.separator + "bordercircleon.png");
    			frameborderoff.load("sprites"+  File.separator + "borderoff.png");
    			frameborderon.load("sprites"+  File.separator + "borderon.png");
    			framebuttonoff.load("sprites"+  File.separator + "buttonoff.png");
    			framebuttonon.load("sprites"+  File.separator + "buttonon.png");
    			framebuttoncircle.load("sprites"+  File.separator + "buttoncircle.png");
    			
    			spritebordercircle.addframe(framebordercircleoff);
    			spritebordercircle.addframe(framebordercircleon);
    			spriteborder.addframe(frameborderoff);
    			spriteborder.addframe(frameborderon);
    			spritebutton.addframe(framebuttonoff);
    			spritebutton.addframe(framebuttonon);
    			spritebuttoncircle.addframe(framebuttoncircle);
  
    			frameBackgroundOptions.load("sprites"+  File.separator + "pianooptions.png");
    			spriteBackgroundOptions.addframe(frameBackgroundOptions);
  
    		}
	void draw(SDLSurface screen){
		//System.out.println("draw");
		
		try {
		spriteBackgroundOptions.draw(screen);

		
		spritebutton.setx(160);
		spriteborder.setx(160);
		
		
		spritebutton.setframe(staffmode);
		spritebutton.sety(205);
		spritebutton.draw(screen);
		
		if (numoption==0){
			spriteborder.setframe(1);
		}
		else{
			spriteborder.setframe(0);
		}
		spriteborder.sety(205);
		spriteborder.draw(screen);
		textArabica8.drawtext(ResourceBundle.getBundle("Language").getString("Partitura"), screen, 170, 210);
		
		if (fullscreen){
			
			spritebutton.setframe(1);
		}
		else{
			spritebutton.setframe(0);
		}
		
		spritebutton.sety(260); // + 55
		spritebutton.draw(screen);
		
		if (numoption==1){
			spriteborder.setframe(1);
		}
		else{
			spriteborder.setframe(0);
		}
		spriteborder.sety(260);
		spriteborder.draw(screen);
		textArabica8.drawtext(ResourceBundle.getBundle("Language").getString("Ventana"), screen, 170, 265);
		
		textArabica8.drawtext("FRAMESKIP", screen, 160, 300);
		text.drawtext("-", screen, 210, 310);
		text.drawtext("+", screen, 275, 310);
		
		if (numoption ==2){
			spritebordercircle.setframe(1);
		}
		else{
			spritebordercircle.setframe(0);
		}
		spritebordercircle.setx(160);
		spritebordercircle.sety(310);
		spritebordercircle.draw(screen);
	
		if (numoption ==3){
			spritebordercircle.setframe(1);
		}
		else{
			spritebordercircle.setframe(0);
		}
		spritebordercircle.setx(225);
		spritebordercircle.draw(screen);
		
		spritebuttoncircle.setx(160);
		spritebuttoncircle.sety(310);
		spritebuttoncircle.draw(screen);
	
		spritebuttoncircle.setx(225);
		spritebuttoncircle.draw(screen);

		textCalculator40.drawtext(String.valueOf(frameskipmax), screen, 335, 315);
		

    	screen.flip(); //Pintamos la pantalla
    	   
	  	//screen.fillRect(0); //borramos la pantalla anterior	
		} catch (SDLException e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
		}
		
	}
public void initgame() throws Exception{ //inicializa
	
	
		event = new Event();
		 		   
		this.maxoption = 4;
	    keyboard = new Keyboard();
	    
	   // MixChunk chunk= SDLMixer.loadWAV("sound/wav.wav");
	    
	    SDLTTF.init();
	    text = new Text();
	    text.init("fonts"+  File.separator + "FreeSerif.ttf");
	    
	    textCalculator20 = new Text();
	    textCalculator20.init("fonts"+  File.separator + "calculator.ttf");
	    textCalculator20.setcolor(47, 131, 43);
	    
	    textCalculator40 = new Text();
	    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
	    textCalculator40.setcolor(47, 131, 43);
	    
	    textCalculator15 = new Text();
	    textCalculator15.init("fonts"+  File.separator + "calculator.ttf",15);
	    textCalculator15.setcolor(47, 131, 43);
	    
	    textArial15 = new Text();
	    textArial15.init("fonts"+  File.separator + "arial.ttf",15);
	    textArial15.setcolor(255, 255,255);
	    
	    textArabica10 = new Text();
	    textArabica10.init("fonts"+  File.separator + "arabica.ttf",10);

	    textArabica10.setcolor(87, 88,90);
	    
	    textArabica8 = new Text();
	    textArabica8.init("fonts"+  File.separator + "arabica.ttf",8);

	    textArabica8.setcolor(87, 88,90);
	    
	    textHand20 = new Text();
	    textHand20.init("fonts"+  File.separator + "brigitte.ttf",20);

	    textHand20.setcolor(0,0,0);

	}

	public void keyboard(SDLSurface screen) throws InvalidMidiDataException, IOException, MidiUnavailableException, SDLException {
		
		int sym = 0;
		event.setEvent();
		
		if (event.isPressed()){
				
			sym = event.getSym();
			
			switch (sym){
    	
		    	case 27 : 
		    		
		 	    	this.end = true;
		 	    	keyboard.waitrelease();
		    		break;
	    	
		    	case 273:
		    		if (this.numoption > 0 ){
		    			this.numoption--;
		    		}
		    		break;
		    	case 274:
		    		if (this.numoption+1 < this.maxoption){
		    			this.numoption++;
		    		}
		    		break;
		    	case 13: //enter
		    		
		    		if (numoption==0){ //modo partitura/vertical
		    			
		    			if (staffmode==0) staffmode=1;
		    			else staffmode=0;
		    		}
		    		if (numoption==1){ //pantalla completa
	  			
		    			fullscreen=!fullscreen;
		    			screen.wmToggleFullScreen();
		    		}
		    		if (numoption==2){ //opcion 2
	
		    			if (frameskipmax>0){
		    				frameskipmax--;
		    			}
		    		}
		    		if (numoption==3){ //opcion 3
	
		    			if (frameskipmax<10){
		    				frameskipmax++;
		    			}
		    		}
	
		    		break;
			}
		}
	    	
	}

	int go(SDLSurface screen){
		
		try {
			this.initsprites();
			
			this.initgame();
			
	
		}
		catch (Exception e) {
			// TODO Auto-generated catch block
			////e.printStackTrace();
		}
		
		while(!this.end){
				
			
		
			try {
				this.draw(screen);
				this.keyboard(screen);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				//e.printStackTrace();
			} 
		}

		return 0 ;
	}
	public static void setOnline(boolean online) {
		Options.online = online;
	}
	public static boolean isOnline() {
		return online;
	}

}
