
import java.io.File;
import java.io.IOException;

import java.util.Calendar;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiUnavailableException;



import sdljava.SDLException;
import sdljava.mixer.SDLMixer;
import sdljava.ttf.SDLTTF;
import sdljava.video.SDLSurface;
import sdljava.x.swig.Mix_Chunk;
import sdljava.x.swig.SWIG_SDLMixer;

public class Play {
	
	private Event event;
	private Piano piano;
	private boolean end ; //determina cuando salir del programa

	private Text text;
	
	private Mix_Chunk[] sounds;
	
	private Text textArial15;
	private Text textArabica10;
	private Text textArabica8;
	private Text textCalculator20;
	private Text textCalculator40;
	
	private Text textCalculator15;
	
	private Text textHand20;
	
	//Key[] listKey;
	private Key[] listKey ; //objetos para las teclas blancas
	
	private Key[] listKeys ; //objetos para las teclas blancas
	   
	private Note[] listNote ; //objetos para las notas
	
	private CFrame frameNoteYellow;
	private CFrame frameNotePurple;
	private CFrame frameNotePink;
	private CFrame frameNoteRed;
	private CFrame frameNoteOrange;
	private CFrame frameNoteBlue;
	
	private CFrame frameWave1n1;
	private CFrame frameWave1n2;
	private CFrame frameWave1n3;
	private CFrame frameWave1n4;
	private CFrame frameWave1n5;
	private CFrame frameWave2n1;
	private CFrame frameWave2n2;
	private CFrame frameWave2n3;
	private CFrame frameWave2n4;
	private CFrame frameWave2n5;
	private CFrame frameWave3n1;
	private CFrame frameWave3n2;
	private CFrame frameWave3n3;
	private CFrame frameWave3n4;
	private CFrame frameWave3n5;
	
	private CFrame frameBackgroundOptions;
	private CSprite spriteBackgroundOptions;
	
	private CFrame frameBackgroundSelectSong;
	private CSprite spriteBackgroundSelectSong;
	
	private 	CFrame frameBackgroundMain;
	private CSprite spriteBackgroundMain;
	
	private CFrame frameBackgroundNotebook;
	private CSprite spriteBackgroundNotebook;
	
	private CFrame frameHand;
	private CSprite spriteHand;
	
	private CSprite spriteWave;
	
	private CFrame frameNoteBorder;
	
	private CFrame frameKey;
	private CFrame frameKeyPush;
	private CFrame frameKeyblack;
	private CFrame frameKeyblackPush;
	private CFrame frameLine;
	
	private CFrame frameOk;
	private CFrame frameBad;
	private CFrame framePerfect;
	
	private CFrame frameStaff;
	private CSprite spriteStaff;
	
	private CFrame frameCrotchet;
	private CSprite spriteCrotchet;
	
	private CFrame frameNoteStaffwhole;
	private CFrame frameNoteStaffhalf;
	private CFrame frameNoteStaffquarter;
	private CFrame frameNoteStaffeighth;
	private CFrame frameNoteStaffsixteenth;

	private CFrame frameNoteStaffAuxLine;
	
	private CSprite spriteNoteStaff;
	
	private CFrame frameCrotchetBorder;
	private CSprite spriteCrotchetBorder;
	
	private CSprite spriteTemp ;
	private 	CSprite [] spritePrecision;
	
	private CSprite spriteNoteStaffAuxLine;
	
	private CSprite spriteNoteBorder;
	
	private CSprite spriteLine;
	private CSprite spriteNote;
	private 	CSprite spriteKey;
	private CSprite spriteKeyblack;
	
	private CFrame framebordercircleoff;
	private CFrame framebordercircleon;
	private CFrame frameborderoff;
	private CFrame frameborderon;
	private CFrame framebuttoncircle;
	private CFrame framebuttonoff;
	private 	CFrame framebuttonon;
	
	private 	CSprite spritebordercircle;
	private CSprite spriteborder;
	private 	CSprite spritebutton;
	private CSprite spritebuttoncircle;
	  
	private Midi[] midi;
	
	private int lastPrecision;
	private int lastNote; //variable que indica el ultimo objeto Nota usado
	private long inittime; //controla el numero de segundos actuales cuando es inicia el programa
	
	private long time; //controla el tiempo actual, reiniciado cuando obtiene una nota
	
	private int channel;
	
	private  Calendar today ;

    
	private  int maxtracks;
	private   int maxnotes;

	private   int maxprecision;
	private    int maxchannel;

    
	private   float tempo ; //multiplicador de tempo de la cancion
    

	private   MidiPlayer player;

    
	private  int interval;
   
	private   Score score;

    
	private    int maxKeys;
	
	private final int numnotes= 25;
	public void initsprites() throws SDLException, IOException{
		
		//init sprites

				framebordercircleoff= new CFrame();
				framebordercircleon= new CFrame();
				frameborderoff= new CFrame();
				frameborderon= new CFrame();
				framebuttoncircle= new CFrame();
				framebuttonoff= new CFrame();
				framebuttonon= new CFrame();
				
				spritebordercircle = new CSprite();
				spriteborder = new CSprite();
				spritebutton = new CSprite();
				spritebuttoncircle = new CSprite();
				
				frameBackgroundNotebook = new CFrame();
				spriteBackgroundNotebook = new CSprite() ;
				
				frameBackgroundOptions = new CFrame();
				spriteBackgroundOptions = new CSprite();
				
				frameBackgroundSelectSong = new CFrame();
				spriteBackgroundSelectSong = new CSprite();
				
				frameBackgroundMain = new CFrame();
				spriteBackgroundMain = new CSprite();
				
				frameHand = new CFrame();
				spriteHand = new CSprite();
				
				frameWave1n1 = new CFrame();
				frameWave1n2= new CFrame();
				frameWave1n3= new CFrame();
			    frameWave1n4= new CFrame();
				frameWave1n5= new CFrame();
			    frameWave2n1= new CFrame();
				frameWave2n2= new CFrame();
				frameWave2n3= new CFrame();
				frameWave2n4= new CFrame();
				frameWave2n5= new CFrame();
				frameWave3n1= new CFrame();
				frameWave3n2= new CFrame();
				frameWave3n3= new CFrame();
				frameWave3n4= new CFrame();
				frameWave3n5= new CFrame();
				
				spriteWave = new CSprite();
				
				frameNoteYellow = new CFrame();
			    frameNotePurple = new CFrame();
				frameNotePink= new CFrame();
				frameNoteRed= new CFrame();
				frameNoteOrange= new CFrame();
				frameNoteBlue= new CFrame();
			    
			    frameKey = new CFrame();
			    frameKeyblack = new CFrame();
			    
			    frameKeyPush = new CFrame();
			    frameKeyblackPush = new CFrame();
			    
			    frameLine = new CFrame();
			    
			    frameNoteBorder = new CFrame();
			    
				 frameOk= new CFrame();
				 frameBad= new CFrame();
				 framePerfect= new CFrame();
				 
				 frameCrotchet = new CFrame();
				 spriteCrotchet = new CSprite();
				 
				 frameCrotchetBorder = new CFrame();
				 spriteCrotchetBorder = new CSprite();
				 	 
				frameNoteStaffwhole = new CFrame();
				frameNoteStaffhalf = new CFrame();
				frameNoteStaffquarter = new CFrame();
				frameNoteStaffeighth = new CFrame();
				frameNoteStaffsixteenth = new CFrame();

				frameNoteStaffAuxLine = new CFrame();
				
				spriteNoteStaff  =new CSprite();
				 
				 frameStaff = new CFrame();
			    
				 spriteStaff = new CSprite();
				 
				 spritePrecision = new CSprite[10];

				spriteTemp =  new CSprite();
				 
			    spriteNoteBorder = new CSprite();
			    
			    spriteLine = new CSprite();
			    spriteNote= new CSprite();
			    spriteKey = new CSprite();
			    spriteKeyblack = new CSprite();
			    
			    spriteNoteStaffAuxLine = new CSprite();
			    
				framebordercircleoff.load("sprites"+  File.separator + "bordercircleoff.png");
				framebordercircleon.load("sprites"+  File.separator + "bordercircleon.png");
				frameborderoff.load("sprites"+  File.separator + "borderoff.png");
				frameborderon.load("sprites"+  File.separator + "borderon.png");
				framebuttonoff.load("sprites"+  File.separator + "buttonoff.png");
				framebuttonon.load("sprites"+  File.separator + "buttonon.png");
				framebuttoncircle.load("sprites"+  File.separator + "buttoncircle.png");
				
				spritebordercircle.addframe(framebordercircleoff);
				spritebordercircle.addframe(framebordercircleon);
				spriteborder.addframe(frameborderoff);
				spriteborder.addframe(frameborderon);
				spritebutton.addframe(framebuttonoff);
				spritebutton.addframe(framebuttonon);
				spritebuttoncircle.addframe(framebuttoncircle);
			    
				frameWave1n1.load("sprites"+  File.separator + "waves/wave1-1.png");
				frameWave1n2.load("sprites"+  File.separator + "waves/wave1-2.png");
				frameWave1n3.load("sprites"+  File.separator + "waves/wave1-3.png");
				frameWave1n4.load("sprites"+  File.separator + "waves/wave1-4.png");
				frameWave1n5.load("sprites"+  File.separator + "waves/wave1-5.png");
				
				frameWave2n1.load("sprites"+  File.separator + "waves/wave2-1.png");
				frameWave2n2.load("sprites"+  File.separator + "waves/wave2-2.png");
				frameWave2n3.load("sprites"+  File.separator + "waves/wave2-3.png");
				frameWave2n4.load("sprites"+  File.separator + "waves/wave2-4.png");
				frameWave2n5.load("sprites"+  File.separator + "waves/wave2-5.png");
				
				frameWave3n1.load("sprites"+  File.separator + "waves/wave3-1.png");
				frameWave3n2.load("sprites"+  File.separator + "waves/wave3-2.png");
				frameWave3n3.load("sprites"+  File.separator + "waves/wave3-3.png");
				frameWave3n4.load("sprites"+  File.separator + "waves/wave3-4.png");
				frameWave3n5.load("sprites"+  File.separator + "waves/wave3-5.png");
				
				frameBackgroundSelectSong.load("sprites"+  File.separator + "pianoselectsong.png");
				spriteBackgroundSelectSong.addframe(frameBackgroundSelectSong);
				
				frameBackgroundMain.load("sprites"+  File.separator + "pianointro.png");
				spriteBackgroundMain.addframe(frameBackgroundMain);
				
				frameBackgroundOptions.load("sprites"+  File.separator + "pianooptions.png");
				spriteBackgroundOptions.addframe(frameBackgroundOptions);
				
				frameBackgroundNotebook.load("sprites"+  File.separator + "notebook.png");
				spriteBackgroundNotebook.addframe(frameBackgroundNotebook);
				
				frameHand.load("sprites"+  File.separator + "hand.png");
				spriteHand.addframe(frameHand);
				
				spriteWave.addframe(frameWave1n1);
				spriteWave.addframe(frameWave1n2);
				spriteWave.addframe(frameWave1n3);
				spriteWave.addframe(frameWave1n4);
				spriteWave.addframe(frameWave1n5);
			    
				spriteWave.addframe(frameWave2n1);
				spriteWave.addframe(frameWave2n2);
				spriteWave.addframe(frameWave2n3);
				spriteWave.addframe(frameWave2n4);
				spriteWave.addframe(frameWave2n5);
				
				spriteWave.addframe(frameWave3n1);
				spriteWave.addframe(frameWave3n2);
				spriteWave.addframe(frameWave3n3);
				spriteWave.addframe(frameWave3n4);
				spriteWave.addframe(frameWave3n5);
			    
			    
			    frameCrotchet.load("sprites"+  File.separator + "crotchet.png");
			    spriteCrotchet.addframe(frameCrotchet);
			    
				frameNoteStaffwhole.load("sprites"+  File.separator + "whole.png");
				frameNoteStaffhalf.load("sprites"+  File.separator + "half.png");
				frameNoteStaffquarter.load("sprites"+  File.separator + "quarter.png");
				frameNoteStaffeighth.load("sprites"+  File.separator + "eighth.png");
				frameNoteStaffsixteenth.load("sprites"+  File.separator + "sixteenth.png");
				
				frameNoteStaffAuxLine.load("sprites"+  File.separator + "auxline.png");
				
				spriteNoteStaff.addframe(frameNoteStaffwhole);
				spriteNoteStaff.addframe(frameNoteStaffhalf);
				spriteNoteStaff.addframe(frameNoteStaffquarter);
				spriteNoteStaff.addframe(frameNoteStaffeighth);
				spriteNoteStaff.addframe(frameNoteStaffsixteenth);
				
				spriteNoteStaffAuxLine.addframe(frameNoteStaffAuxLine);
			    
			    frameCrotchetBorder.load("sprites"+  File.separator + "crotchetborder.png");
			    spriteCrotchetBorder.addframe(frameCrotchetBorder);
			    
			    frameStaff.load("sprites"+  File.separator + "staff.png");
			    spriteStaff.addframe(frameStaff);
			    
			    frameNoteYellow.load("sprites"+  File.separator + "noteyellow.png");
			    frameNotePurple.load("sprites"+  File.separator + "notepurple.png");
			    frameNotePink.load("sprites"+  File.separator + "notepink.png");
			    frameNoteRed.load("sprites"+  File.separator + "notered.png");
			    frameNoteOrange.load("sprites"+  File.separator + "noteorange.png");
			    frameNoteBlue.load("sprites"+  File.separator + "noteblue.png");
			    
			    
			    spriteNote.addframe(frameNoteYellow);
			    spriteNote.addframe(frameNotePurple);
			    spriteNote.addframe(frameNoteRed);
			    spriteNote.addframe(frameNotePink);
			    spriteNote.addframe(frameNoteOrange);
			    spriteNote.addframe(frameNoteBlue);
			    
			   
			    
				 frameOk.load("sprites"+  File.separator + "ok.png");
				 frameBad.load("sprites"+  File.separator + "bad.png");
				 framePerfect.load("sprites"+  File.separator + "perfect.png");
				 
				 spriteTemp.addframe(frameOk);
				 spriteTemp.addframe(frameBad);
				 spriteTemp.addframe(framePerfect);
			    
			    for (int i=0;i<10;i++){

			    	spritePrecision[i] = new CSprite();
			    	
			    	spritePrecision[i].addframe(frameOk);
			    	spritePrecision[i].addframe(frameBad);
			    	spritePrecision[i].addframe(framePerfect);
			    }
				 
			    frameKey.load("sprites"+  File.separator + "key.png");
			    frameKeyPush.load("sprites"+  File.separator + "keypush.png");
			    spriteKey.addframe(frameKey);
			    spriteKey.addframe(frameKeyPush);
			    
			    frameKeyblack.load("sprites"+  File.separator + "keyblack.png");
			    frameKeyblackPush.load("sprites"+  File.separator + "keyblackpush.png");
			    spriteKeyblack.addframe(frameKeyblack);
			    spriteKeyblack.addframe(frameKeyblackPush);
			    
			    frameLine.load("sprites"+  File.separator + "line.png");
			    spriteLine.addframe(frameLine);
			    
			    frameNoteBorder.load("sprites"+  File.separator + "noteborder.png");
			    spriteNoteBorder.addframe(frameNoteBorder);

			}
			
			public void initgame() throws Exception{ //inicializa
				
				try{
					sounds = new Mix_Chunk[numnotes];
					for (int i=0;i<numnotes;i++){
						sounds[i] = SWIG_SDLMixer.SWIG_Mix_LoadWAV("sound"+ File.separator + "piano"+ File.separator + (i + 60) +".wav");
						
					}
				}
				catch(Exception e){
					System.out.println("Error al cargar los sonidos");
				}
				event = new Event();
				
				try{
					piano = new Piano();
				
				//piano.getdevices();
					piano.init();
				}
				catch(Exception e){
					System.out.println("Error play.draw , no se puede inicializar piano "+e);
				}
			//	language = new Language();
				//language.load();
				
			
				
				player = new MidiPlayer();
				
				score = new Score();
				
				interval = 7500;
				
				end = false;

		  	    maxprecision = 10; //mensajes de bad, ok, perfect en pantalla
		  	   
		  	  maxKeys = 30;       //numero de teclas, blancas y negras por separado
		  	    
		  	    maxnotes = 50; //numero de notas simultaneas en pantalla
		  	    maxtracks = 20; //maximo numero de tracks por midi
		  	    maxchannel = 5; //maximo numero de canales de sonido (sonidos simultáneos)
		  	    
		  	    //MixChunk chunk= SDLMixer.loadWAV("sound/wav.wav");
		  	    //  Mix_Chunk chunk = SWIG_SDLMixer.SWIG_Mix_LoadWAV("sound/wav.wav");
		  	   
			   // MixChunk chunk= SDLMixer.loadWAV("sound/wav.wav");
			    
			    SDLTTF.init();
			    text = new Text();
			    text.init("fonts"+  File.separator + "FreeSerif.ttf");
			    
			    textCalculator20 = new Text();
			    textCalculator20.init("fonts"+  File.separator + "calculator.ttf");
			    textCalculator20.setcolor(47, 131, 43);
			    
			    textCalculator40 = new Text();
			    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
			    textCalculator40.setcolor(47, 131, 43);
			    
			    textCalculator15 = new Text();
			    textCalculator15.init("fonts"+  File.separator + "calculator.ttf",15);
			    textCalculator15.setcolor(47, 131, 43);
			    
			    textArial15 = new Text();
			    textArial15.init("fonts"+  File.separator + "arial.ttf",15);
			    textArial15.setcolor(255, 255,255);
			    
			    textArabica10 = new Text();
			    textArabica10.init("fonts"+  File.separator + "arabica.ttf",10);

			    textArabica10.setcolor(87, 88,90);
			    
			    textArabica8 = new Text();
			    textArabica8.init("fonts"+  File.separator + "arabica.ttf",8);

			    textArabica8.setcolor(87, 88,90);
			    
			    textHand20 = new Text();
			    textHand20.init("fonts"+  File.separator + "brigitte.ttf",20);

			    textHand20.setcolor(0,0,0);
			    

			}
			public void initsong(String song) throws InvalidMidiDataException, IOException, MidiUnavailableException{
				
				piano.start();
				score = new Score();
				
				channel = 0;
		  	    //tempo = player.gettempo();
		    	tempo = player.gettempo();
		    //	System.out.println(tempo);
		  	   
		  	    today = Calendar.getInstance();
				inittime = today.getTimeInMillis() +2000;
				time = 0 ;
				lastPrecision=0;
			
				lastNote = 0;
				
				 //path = "/home/rephus/workspace/prueba/music/";
				    //midi.parseMidi("/home/rephus/workspace/prueba/music/prueba.mid");
				   
				//path = "music/";
				
				//path = "music" + File.separator;
				
				midi = new Midi[50];
			    for (int i=0;i<maxtracks;i++){
			    	midi[i] = new Midi();

			    		//midi[i].initFile(FileBrowser.getFolderSongs()+File.separator + song +".mid");
			    	midi[i].initFile(song );
			    		
			    	
			    }
			    
			   // tempo = midi[0].gettempo() /120;
			   // System.out.print(tempo);
			
			    for (int i=0;i<maxnotes;i++){

			    	listNote[i].setinactive();
			    }
			    
			    for (int i=0;i<maxprecision;i++){

			    	spritePrecision[i].setinActive();
			    }
			    
			}
			 public void initobjects() throws SDLException{
			    	
		    	 listKeys = new Key[maxKeys];
		 	   
		 	     for (int i=0;i<maxKeys;i++){

		 	    	listKeys[i] = new Key();
		 	    	
		 	    }
			     listNote = new Note[maxnotes]; //este máximo determina el número de notas simultaneas en funcionamiento
			  
			    for (int i=0;i<maxnotes;i++){


			    	listNote[i] = new Note();

			    }
		    	
		    }
	public void draw(SDLSurface screen) throws SDLException, MidiUnavailableException, InvalidMidiDataException{
		
		if (Options.staffmode==0){
			
			spriteLine.sety(10);
			spriteLine.setx(-5);
			
			//spriteLine.addzoom(5);
			
		  	for (int l=0;l<=14;l++){ //bucle pintar lineas para las blancas
		  		
		  		spriteLine.setx(spriteLine.getx() + spriteKey.getw());
		  		spriteLine.draw(screen); //pinta lineas
		  		
		  	}
		  	spriteLine.setx(20);
		  	for (int l=0;l<=12;l++){ //bucle pintar lineas para las negras
		  	
		  		spriteLine.setx(spriteLine.getx() + spriteKey.getw());
		  		
		  		if ( (l != 2) && 
		  				(l != 6) && 
		  				(l != 9) ){ //no pintes donde no hay
		  			
		  			spriteLine.draw(screen); //pinta lineas 
		  		}
		  		
		  	}
			
		}		//Options.staffmode==0
		else{
			
			spriteStaff.setx(10);
			spriteStaff.sety(10);
			spriteStaff.draw(screen);
		}
		
	  	
	  	spriteKey.sety(470);
	  	spriteKey.setx(-30);
	  	
	  	spriteKeyblack.sety(470);
	  	spriteKeyblack.setx(-3);
	  	for (int i=0;i<=24;i++){ //bucle pintar blancas
	 
	  		if (Midi.isBlack(i+60)){
	  			
	  		}
	  		else{
	  			if ( listKeys[i].getactive() == 1){
	  				spriteKey.setframe(1);
	  			}
	  			else {
	  				spriteKey.setframe(0);
	  			}
	  			 //aumenta la diferencia segun las notas	
		  		
	    	  	spriteKey.setx(spriteKey.getx() + spriteKey.getw());
	    	  	spriteKey.draw(screen); //pinta blancas
	  		}
	  		
	  	}
	  	for (int i=0;i<=24;i++){ //bucle pintar blancas
	  		 
	  		if (Midi.isBlack(i+60)){
	  			
	  			if ( listKeys[i].getactive() == 1){
	  				spriteKeyblack.setframe(1);
	  			}
	  			else {
	  				spriteKeyblack.setframe(0);
	  			}
	  			
	  			spriteKeyblack.draw(screen);
	  		}
	  		else{

	  			spriteKeyblack.setx(spriteKeyblack.getx() + spriteKey.getw());
	    	  
	  		}
	  		
	  	}

	  	if (Options.staffmode==0){
	  		
	  		for (int i=0;i<maxnotes;i++){ //pintar las notas
		  		
		  		if ( (listNote[i].getactive()==1) && (listNote[i].getPush() ==1 ) ){ //no se pintan las notas de liberacion = numero de notas disponibles / 2

	  				if (listNote[i].isBlack() ){//pintamos el borde correspondiente
	  					
	  				}
	  				else {
	  					//spriteNoteBorder.addzoom(5);
	  					
		  		  	  	spriteNoteBorder.sety(500);
		  	    	  	spriteNoteBorder.setx(listNote[i].getx());
		  				
		  				spriteNoteBorder.draw(screen);
		  			}
	  				
	  				//System.out.println(spriteCrotchet.getx());
	  				
		  			spriteNote.setframe(listNote[i].getNote() % 6 ); //el modulo depende del numero de sprites diferentes
		  			
		  			spriteNote.setx(listNote[i].getx());
		  			spriteNote.sety(listNote[i].gety());
	  				spriteNote.draw(screen);
		  		}

		  	}
	  		
	  	}
	  	else { //Options.staffmode=1
	  		
	  		for (int i=0;i<maxnotes;i++){ //pintar las notas
	  			

		  		if ( (listNote[i].getactive()==1) && (listNote[i].getPush() ==1 ) ){ //no se pintan las notas de liberacion = numero de notas disponibles / 2
		  		
		  			if (listNote[i].getStaffy() == 90 ){
		  				spriteNoteStaffAuxLine.setx(listNote[i].getStaffx());
		  				spriteNoteStaffAuxLine.sety(listNote[i].getStaffy());
		  				spriteNoteStaffAuxLine.draw(screen);
		  			}
		  			
		  			spriteCrotchetBorder.setx(250);
		  			spriteCrotchetBorder.sety(listNote[i].getStaffy());
		  			spriteCrotchetBorder.draw(screen);
		  		/*	
		  			spriteCrotchet.setx(listNote[i].getStaffx());
		  			spriteCrotchet.sety(listNote[i].getStaffy());
		  			spriteCrotchet.draw(screen);
		  			*/
		  			spriteNoteStaff.setframe(listNote[i].getDuration()-1);
		  			spriteNoteStaff.setx(listNote[i].getStaffx());
		  			spriteNoteStaff.sety(listNote[i].getStaffy());
		  			spriteNoteStaff.draw(screen);
		  			
		  		}		  		
	
	  		}

	  	}
		/*spritePrecision.setx(10);
		spritePrecision.sety(10);
		spritePrecision.setframe(2);
		spritePrecision.draw(screen);
		*/
	  	for (int i = 0;i<10;i++){
	    	if (spritePrecision[i].isActive()){
	    		spritePrecision[i].draw(screen);	//Pintamos el acierto de las notas
	    	}
	  	}

		if (midi[0].getDurationRemaining((int) time - interval)> 0 ) {
		}
		else{
			text.drawtext("0 segundos", screen, 500, 30);
			text.drawtext("0 milisegundos", screen, 650, 30);
		
		}

	  	text.drawtext(String.valueOf(score.getScore()), screen, 10, 10); //pintamos un texto de prueba con el tiempo
	  	
	  	screen.flip(); //Pintamos la pantalla
	   
	  	screen.fillRect(0); //borramos la pantalla anterior
	 
	}
	public void getnote() throws MidiUnavailableException, InvalidMidiDataException { //obtiene la siguiente nota si el tiempo es mayor que el tick
		
		for (int i=1;i<=midi[0].gettracks() ;i++){ //obtenemos notas de todos los tracks
	  		 
	  		//System.out.println(midi[i].gettick(i));
	  		
			//System.out.println(tempo);
	  		if (time  >= midi[i].gettick(i) * 120/tempo  ){ //dividmos por 1000 para calcular milisegundos
	  		
  			    listNote[lastNote] = midi[i].getNote(i); //obtenemos la nota del siguiente evento
  			    
  			    if( (listNote[lastNote].getactive()==1) && (listNote[lastNote].getPush()==1) ){
  			    	//System.out.println("nota "  + listNote[lastNote].getNote());
  			    	lastNote++;
  			    	
  			    }
	  			
    		   // System.out.println("SOY LA NOTA EN EL PROGRAMA PRINCIPAL" + listNote[lastNote].getNote());
	  			//temp= 50 ;//listNote[lastNote].getTempo();
	  			//System.out.println(temp);
	  			//time=0;

	  		}
	  		
	  	 } //end for
	}
	public int getlowernote(int note){
	
	int max= 0;
	int list=-1;
	for (int i = 0 ; i<=24;i++){
		
		if ((listNote[i].getNote() == note) && (listNote[i].getactive() ==1)){
			
			if (max < listNote[i].gety() ){
				
				max=listNote[i].gety();
				list= i ;
				
			}
			
		}
		
	}
	return list;
			
	}

public void constant() throws MidiUnavailableException, InvalidMidiDataException, IOException { //resto de procedimientos constantes del menu 1


	if (midi[0].getDurationRemainingseconds((int) time -interval)  < -5 ){
		//por defecto a -5
		//end of song
		
		score.setScore(800);
		//score.save(song);
		//score.saveUser(song,user.getUser());
		this.end= true;
		
	}
	
		if (maxnotes -2<= lastNote){
			lastNote = 0;
		}
		if (maxprecision -2<= lastPrecision){
			lastPrecision = 0;
		}
		
		if (maxchannel < channel ){
			channel = 0;
		}
	  //  System.out.println(today.getTimeInMillis());
	    
		//System.out.println(midi[0].gettracks());
		
	 
		//System.out.println("lastPrecision  "+lastPrecision);
	  for (int i=0;i<maxnotes;i++){ //bucle desaparecedor de notas, si no hemos pulsado saldra un bad
		
		  if ((listNote[i].getactive() == 1) && (listNote[i].getPush()==1)){
			  
			 // System.out.println(listNote[i].getStaffx());
			  listNote[i].setStaffx(listNote[i].getStaffx()-2); //velocidad horizontal
			  
		  }
		  if ((listNote[i].getactive() == 1) && (listNote[i].getPush()==1)){
			  
			  listNote[i].sety(listNote[i].gety()+2); //velocidad verticalproyect
			  
		  }
		  if (listNote[i].isBlack()){
	    	  if ( (listNote[i].gety() > 450) && (listNote[i].getactive()==1) ){
	    	  		listNote[i].setinactive();
	    	  		listNote[i].sety(0);
	    	  		
  					spritePrecision[lastPrecision].setframe(1);
  				
  	  				spritePrecision[lastPrecision].setx(listNote[i].getx());
  	  				spritePrecision[lastPrecision].sety(450);
  	  				spritePrecision[lastPrecision].setActive();
  	  			    spritePrecision[lastPrecision].setTimeactive();
  	  				
  	  			    lastPrecision++;
	    	  }
			  
		  }
		  else{
			  
		  
    	  	if( (listNote[i].gety() > 500) && (listNote[i].getactive()==1) ){
	    	  		listNote[i].setinactive();
	    	  		listNote[i].sety(0);
	    	  		
  					spritePrecision[lastPrecision].setframe(1);
  	  				
  	  				spritePrecision[lastPrecision].setx(listNote[i].getx());
  	  				spritePrecision[lastPrecision].sety(450);
  	  				spritePrecision[lastPrecision].setActive();
  	  				spritePrecision[lastPrecision].setTimeactive();
  	  				
  	  				lastPrecision++;
  	  				System.out.println("nota "+listNote[i].getNote());
  	  			}
		  }
		 
	  } //END for
  	
  	for (int i = 0;i<10;i++){
    	if (spritePrecision[i].getTimeactive() == 0){
    		spritePrecision[i].setinActive();
    		
    	}
    	else{
    		
    		spritePrecision[i].reducetimeactive();
    	}
  	}

  	//actualizamos el time en milisegundos
  	  today = Calendar.getInstance();
	  time =today.getTimeInMillis() -inittime;
}
	public void evaluatenotekeyboard() { //comprueba si se acierta la nota con el teclado
	
		try{
			if ((event.isPressed())   ){
				boolean inactive = false;
				int i = 0;
				int min = 0;
				int note = 0;
				int sym = event.getSym();
				//System.out.println((char) sym +" : "+sym  );
				
				note = event.symtonote(sym);
				
				SWIG_SDLMixer.SWIG_Mix_PlayChannel(channel, sounds[note-60], 0);
		  		channel++;
		  			
				while((i<=24) && (!inactive)){
					if ((listNote[i].getNote() == note) && (listNote[i].getactive() == 1)){
						
						min = this.getlowernote(note);
						if ((listNote[min].gety() > 450)){//&& (listNote[j].gety() < 500)){ // y si esa nota esta por debajo de una altitud
		  					//perfect
		  					score.addScore("perfect");
		  					
		  					spritePrecision[lastPrecision].setframe(2);
		  					
	    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				listNote[min].setinactive(); //la desactivamos
	    	  			
	    	  				inactive = true;
		  				}  
		  				else if ((listNote[min].gety() > 400)){//&& (listNote[j].gety() < 500)){
		  					//good
		  					score.addScore("good");
		  					
		  					spritePrecision[lastPrecision].setframe(0);
		  					
	    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				listNote[min].setinactive(); //la desactivamos
	    	  				
	    	  				inactive = true;
		  				}
		  				else if ((listNote[min].gety() > 350)){//&& (listNote[j].gety() < 500)){
		  					//bad
		  					spritePrecision[lastPrecision].setframe(1);
	    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				
	    	  				listNote[min].setinactive();
	    	  				
	    	  				inactive = true;
		  				}
					}
				
				i++;
				}
			}
		}
		catch(Exception e){
			
		}
	}
	public void evaluatenotepiano() { //comprueba si se acierta la nota con el teclado
		
		try {
			
		if (true){
			
			int note = 0;
			boolean inactive = false;
			int i = 0;
			int min = 0;
			for (int j = 0;j<=numnotes;j++){
				
				if (piano.getPressed(j)){
					piano.setPressed(j, false);
					note = j+60;
					System.out.println(note);
					
					try{
					
						SWIG_SDLMixer.SWIG_Mix_PlayChannel(channel, sounds[note-60], 0);
				  		channel++;
					}
					catch(Exception e){
						System.out.println("Error evaluatepiano.play no existe sonido "+e);
					}
			  		while((i<=24) && (!inactive)){
						if ((listNote[i].getNote() == note) && (listNote[i].getactive() == 1)){
							
							min = this.getlowernote(note);
							if ((listNote[min].gety() > 450)){//&& (listNote[j].gety() < 500)){ // y si esa nota esta por debajo de una altitud
			  					//perfect
			  					score.addScore("perfect");
			  					
			  					spritePrecision[lastPrecision].setframe(2);
			  					
		    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
		    	  				spritePrecision[lastPrecision].sety(450);
		    	  				spritePrecision[lastPrecision].setActive();
		    	  				spritePrecision[lastPrecision].setTimeactive();
		    	  				
		    	  				lastPrecision++;
		    	  				listNote[min].setinactive(); //la desactivamos
		    	  			
		    	  				inactive = true;
			  				}  
			  				else if ((listNote[min].gety() > 400)){//&& (listNote[j].gety() < 500)){
			  					//good
			  					score.addScore("good");
			  					
			  					spritePrecision[lastPrecision].setframe(0);
			  					
		    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
		    	  				spritePrecision[lastPrecision].sety(450);
		    	  				spritePrecision[lastPrecision].setActive();
		    	  				spritePrecision[lastPrecision].setTimeactive();
		    	  				
		    	  				lastPrecision++;
		    	  				listNote[min].setinactive(); //la desactivamos
		    	  				
		    	  				
		    	  				inactive = true;
			  				}
			  				else if ((listNote[min].gety() > 350)){//&& (listNote[j].gety() < 500)){
			  					//bad
			  					spritePrecision[lastPrecision].setframe(1);
		    	  				spritePrecision[lastPrecision].setx(listNote[min].getx());
		    	  				spritePrecision[lastPrecision].sety(450);
		    	  				spritePrecision[lastPrecision].setActive();
		    	  				spritePrecision[lastPrecision].setTimeactive();
		    	  				
		    	  				lastPrecision++;
		    	  				
		    	  				listNote[min].setinactive();
		    	  				
		    	  				inactive = true;
			  				}
						}
					
					i++;
					}
			  		
					
				}
				
			}
		}//end if
		}//end try
		catch(Exception e){
			
		}
	}

	/*public void evaluatenotepiano2() throws InterruptedException { //comprueba si se acierta la nota con el teclado
		
		int i=0;
		boolean buleano = true;
		while (( i<=24) && (buleano) ){
		
			//System.out.println(listNote[i].getNote());
		//for (int i = 0;i<=24;i++){ //vamos a comprobar las teclas del piano (solo blancas)
			if ((!piano.getused()) && (piano.getpush() == 1)){
			
				if (listNote[i].getactive() == 1){
					try{
						//SWIG_SDLMixer.SWIG_Mix_PlayChannel(channel, sounds[listNote[i].getNote()-60], 0);
			  			channel++;
					}
					catch(Exception e){
						
					}
					System.out.println(piano.getnote());
					if (piano.getnote() == listNote[i].getNote() ){
						
						
		  				if ((listNote[i].gety() > 450)){//&& (listNote[j].gety() < 500)){ // y si esa nota esta por debajo de una altitud
		  					//perfect
		  					score.addScore("perfect");
		  					
		  					spritePrecision[lastPrecision].setframe(2);
		  					
	    	  				spritePrecision[lastPrecision].setx(listNote[i].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				listNote[i].setinactive(); //la desactivamos
	    	  				
	    	  				piano.setused(true);
		  				}  
		  				else if ((listNote[i].gety() > 400)){//&& (listNote[j].gety() < 500)){
		  					//good
		  					score.addScore("good");
		  					
		  					spritePrecision[lastPrecision].setframe(0);
		  					
	    	  				spritePrecision[lastPrecision].setx(listNote[i].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				listNote[i].setinactive(); //la desactivamos
	    	  				
	    	  				piano.setused(true);
		  				}
		  				else if ((listNote[i].gety() > 350)){//&& (listNote[j].gety() < 500)){
		  					//bad
		  					spritePrecision[lastPrecision].setframe(1);
	    	  				spritePrecision[lastPrecision].setx(listNote[i].getx());
	    	  				spritePrecision[lastPrecision].sety(450);
	    	  				spritePrecision[lastPrecision].setActive();
	    	  				spritePrecision[lastPrecision].setTimeactive();
	    	  				
	    	  				lastPrecision++;
	    	  				
	    	  				listNote[i].setinactive();
	    	  				
	    	  				piano.setused(true);
		  				}
						//System.out.println("misma nota " + piano.getnote());
						
					}
				}
	
			}
			
			i++;
			
		}//fin for
		piano.setused(true);
		
	}*/
	public void keyboard() throws SDLException, InterruptedException, MidiUnavailableException{
		
		//System.out.println(piano.getpush());
		//System.out.println(piano);
		int sym = 0;
		event.setEvent();
		
		if (event.isPressed()){
				
			sym = event.getSym();
			
			switch (sym){
				case 27:
					this.end = true;
					break;
				
			}
		}
	}
	
	int go (SDLSurface screen,String song){
		
		//System.out.println("inicio play");
		
		try {

			this.initsprites();
			System.out.println("sprites iniciados");

			this.initgame();
			System.out.println("juegos iniciados");

			this.initobjects();
			
			//this.player.play("music" + File.separator + song);
			this.player.init(song);
			this.initsong(song);

			System.out.println("objetos iniciados");

		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} 
		this.end = false;
		while (!this.end){
			

			try {
				
				this.draw(screen);
				
	    		this.keyboard();
	    	  	
	    		this.getnote();
	    		
	    		this.evaluatenotepiano();
	    		this.evaluatenotekeyboard();
	    		//evaluatenote();
	    		//evaluatenoteblack();

	    		this.constant();

			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		System.out.println("salida del bucle");

		return 0 ;
		}
	
	}
