

import java.io.File;
import java.io.IOException;
import java.util.Locale;

import database.TableUsers;

import sdljava.*;
import sdljava.audio.SDLAudio;
import sdljava.mixer.SDLMixer;
import sdljava.ttf.SDLTTF;
import sdljava.video.*;

public class SDLMainTest {
	
//---------------------------------------------------------    	  	
//DECLARAR VARIABLES
//---------------------------------------------------------

	private boolean end ; //determina cuando salir del programa
	private boolean fullscreen ;
	
	//private Language language ;
	
	private SDLSurface screen;
	private Text text;

	private Text textCalculator40;

	private User user;
	
	private Options options;
	
	private 	CFrame frameBackgroundMain;
	private CSprite spriteBackgroundMain;

	private CFrame frameHand;
	private CSprite spriteHand;
	
	private   int maxmenu;
   
	private  int nummenu;
   
	private Event event;
	public void initsystem() throws SDLException{
    	
    	SDLMain.init(SDLMain.SDL_INIT_AUDIO);
			
		 //public static void openAudio(int frequency, int format, int channels, int chunksize) 
		SDLMixer.openAudio(22000, SDLAudio.AUDIO_S16SYS,2, 1024); //aumentando chunksize disminuye el tiempo de aparicion del sonido, pero disminuye calidad
       // SDLMixer.openAudio(22050, SDLAudio.AUDIO_S16SYS, 1, 1024); //aumentando chunksize disminuye el tiempo de aparicion del sonido, pero disminuye calidad

		//System.out.println(SDLVideo.videoDriverName());
		SDLMain.init(SDLMain.SDL_INIT_EVERYTHING);
	    screen = SDLVideo.setVideoMode(800, 600, 32,SDLVideo.SDL_SWSURFACE|SDLVideo.SDL_ANYFORMAT);
    	
    }

    public void close(){
    		
    	//System.out.println("Gracias por jugar");
    	if (options.getFullscreen()){
			screen.wmToggleFullScreen();
			fullscreen=!fullscreen;
    	}
    
    }
	public void initsprites() throws SDLException, IOException{
		
//init sprites

		frameBackgroundMain = new CFrame();
		spriteBackgroundMain = new CSprite();
		
		frameHand = new CFrame();
		spriteHand = new CSprite();
		
	
		frameBackgroundMain.load("sprites"+  File.separator + "pianointro.png");
		spriteBackgroundMain.addframe(frameBackgroundMain);

		frameHand.load("sprites"+  File.separator + "hand.png");
		spriteHand.addframe(frameHand);
		
	}
	
	public void init() throws Exception{ //inicializa
		
		event = new Event();
		//piano.getdevices();
		
		options = new Options();
		fullscreen=false;
		
		nummenu=0;
		
		maxmenu=4;
		
		end = false;
		user = new User();

	    SDLTTF.init();
	    text = new Text();
	    text.init("fonts"+  File.separator + "FreeSerif.ttf");
	    
	    textCalculator40 = new Text();
	    textCalculator40.init("fonts"+  File.separator + "calculator.ttf",40);
	    textCalculator40.setcolor(47, 131, 43);


	}
	
//---------------------------------------------------------    	  	
//PROCESOS PINTAR
//---------------------------------------------------------

	@SuppressWarnings("static-access")
	public void draw() throws SDLException, InterruptedException{
		
		spriteBackgroundMain.draw(screen);
		
		//textCalculator15.drawtext( language.getString(3) + " : " , screen, 133, 80);
		if (user.getUser().getName().length() < 9 ){
			textCalculator40.drawtext(" " + user.getUser().getName() , screen, 133, 75);

		}
		else{
			textCalculator40.drawtext(" " + user.getUser().getName().substring(0,9) , screen, 133, 80);

		}
		
		spriteHand.sety(450);
		if (spriteHand.getx() < 100 + nummenu*60){
			spriteHand.setx(spriteHand.getx() +5  );
	
		}
		else if (spriteHand.getx() >100 + nummenu*60){
			spriteHand.setx(spriteHand.getx() -5);
			
		}
		spriteHand.draw(screen);
		
		screen.flip(); //Pintamos la pantalla
		   
	  //	screen.fillRect(0); //borramos la pantalla anterior
	  
	}

//---------------------------------------------------------    	  	
//PROCESOS INPUT
//---------------------------------------------------------
	public void keyboard(){
		
		int sym = 0;
		event.setEvent();
		
		if (event.isPressed()){
			
			sym = event.getSym();
			
			switch (sym){
			
			case 27 :  //esc
	    		
	 	    	nummenu = maxmenu-1;
	    		break;
		
	    	case 273:
	    		if (nummenu > 0 ){
	    			
	    			nummenu--;
	    		}
	    		break;
	    	case 274:
	    		if (nummenu+1 < maxmenu){
	    			nummenu++;
	    		}
	    		break;
	    	case 13:
	    		
	    		if (nummenu==0){ //nueva partida
	    			
			    	SelectSong selectsong = new SelectSong();
			    	
			    	selectsong.go(this.screen);
	    			
	    			//player.play("music"+ File.separator + filebrowser.getfile("music",numfile));
	    		}
	    		if (nummenu==1){ //opciones
	    			
			    	options.go(this.screen);
	    			
	    		}
	    		if (nummenu==2){ //usuarios
	    		
	    			user.go(this.screen);
	    			
	    		}
	    		if (nummenu==3){ //salir
	    			
		    		end = true;
	    			
	    		}

			
			}
		}
		
	}

	
//---------------------------------------------------------    	  	
//PROCESO MAIN
//---------------------------------------------------------
	public static void main(String[] args) throws Exception {
   
		new SDLMainTest().run();
	}
	
//---------------------------------------------------------    	  	
//PROCESO PRINCIPAL
//---------------------------------------------------------

	@SuppressWarnings("static-access")
	public void run() throws Exception{
		
//---------------------------------------------------------    	  	
//INICIALIZAR
//---------------------------------------------------------	
		initsystem();
		
		init();
		
		Locale currentLocale = Locale.getDefault();
		System.out.println( currentLocale );
		
		Popup popup = new Popup();
    	popup.set("Conectividad", "Este juego dispone de dos modos de juego, uno online y otro offline, seleccione su modo de juego","offline","online");
    	int sel = popup.go(screen);
    	
    	if (sel==1){
    		Options.setOnline(false);
    		user.go(screen);
    		
    		if (user.getUser() == null){
    			TableUsers anonymous = new TableUsers();
    			anonymous.setName("Anonymous");
    			anonymous.setPass("");
    			anonymous.setEmail("");
    			//anonymous.setAdded(Date.parse("0000-00-00"));
    			user.setUser(anonymous);
    		}
  
    	}
    	else{
    		Options.setOnline(true);
    		
        	Login login = new Login();
        	login.set("titulo", "mensaje");
        	login.go(screen);
 
    	}

		initsprites();

		
//---------------------------------------------------------    	  	
//BUCLE PRINCIPAL
//---------------------------------------------------------		

	    while (!end){ //bucle principal del juego
	
		    draw();
		    keyboard();
		   
    	} //fin while
	   
	    close();
	    
	    System.exit(0);
	    
	  } //fin Main
	
}
